'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AvRegionsFactory = function AvRegionsFactory(AvApiResource, avUsersResource) {
  var AvRegionsResource = function (_AvApiResource) {
    _inherits(AvRegionsResource, _AvApiResource);

    function AvRegionsResource() {
      _classCallCheck(this, AvRegionsResource);

      return _possibleConstructorReturn(this, (AvRegionsResource.__proto__ || Object.getPrototypeOf(AvRegionsResource)).call(this, {
        path: '/api/sdk/platform',
        name: '/regions',
        sessionBust: false,
        pageBust: true
      }));
    }

    _createClass(AvRegionsResource, [{
      key: 'afterGet',
      value: function afterGet(response) {
        return response.data.regions || [];
      }
    }, {
      key: 'afterUpdate',
      value: function afterUpdate(response) {
        this.setPageBust();
        return response;
      }
    }, {
      key: 'getRegions',
      value: function getRegions(config) {
        var _this2 = this;

        return this.checkUser(config).then(function (checkedConfig) {
          return _this2.query(checkedConfig);
        });
      }
    }, {
      key: 'checkUser',
      value: function checkUser() {
        var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


        config.params = config.params || {};
        if (config.params.userId) {
          return Promise.resolve(config);
        }

        return avUsersResource.me().then(function (user) {
          config.params.userId = user.id;
          return config;
        });
      }
    }, {
      key: 'getCurrentRegion',
      value: function getCurrentRegion() {
        return this.query({
          params: {
            currentlySelected: true
          }
        });
      }
    }]);

    return AvRegionsResource;
  }(AvApiResource);

  return new AvRegionsResource();
};

_module2.default.factory('avRegionsResource', AvRegionsFactory);

exports.default = _module2.default;