'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('../../core/analytics/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvAnalyticsController = function () {
  function AvAnalyticsController(avAnalyticsUtils, avAnalytics) {
    _classCallCheck(this, AvAnalyticsController);

    this.av = { avAnalyticsUtils: avAnalyticsUtils, avAnalytics: avAnalytics };
  }

  _createClass(AvAnalyticsController, [{
    key: 'onEvent',
    value: function onEvent(event, element, options) {
      var _this = this;

      var properties = _angular2.default.extend({
        level: 'info',
        label: element.text()
      }, {
        event: event.type
      }, options);

      if (this.av.avAnalyticsUtils.isExternalLink(properties)) {
        event.preventDefault();
        event.stopPropagation();
      }

      var promise = this.av.avAnalytics.trackEvent(properties);
      promise.finally(function () {
        if (_this.av.avAnalyticsUtils.isExternalLink(properties)) {
          document.location = element.attr('href');
        }
      });
    }
  }]);

  return AvAnalyticsController;
}();

_module2.default.controller('AvAnalyticsController', AvAnalyticsController);