'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('angular-sanitize');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

_module2.default.requires.push('ngSanitize');

var AvValContainerController = function () {
  function AvValContainerController($scope, AV_UI) {
    _classCallCheck(this, AvValContainerController);

    this.av = { $scope: $scope, AV_UI: AV_UI };
  }

  _createClass(AvValContainerController, [{
    key: 'message',
    value: function message(context) {
      var _this = this;

      var ngModel = context.ngModel;


      var message = null;
      var violations = Object.keys(ngModel.$error);
      if (violations.length) {
        var validator = violations[0];
        var constraint = ngModel.$validators[validator] && ngModel.$validators[validator].constraint;
        if (constraint) {
          message = constraint.message;
        } else {
          message = this.av.AV_UI.FALLBACK_VALIDATION_MESSAGE;
        }
      } else {
        message = null;
      }

      // $applyAsync is needed to update the UI from $broadcast events
      this.av.$scope.$applyAsync(function () {
        _this.av.$scope.vm.message = message;
      });
    }
  }]);

  return AvValContainerController;
}();

_module2.default.directive('avValContainer', function () {
  return {
    restrict: 'AE',
    controller: AvValContainerController,
    template: '<p class="help-block" ng-bind-html="vm.message"></p>',
    replace: true,
    scope: {},
    link: function link(scope) {
      scope.vm = { message: null, id: null };
    }
  };
});